<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { watch, inject } from 'vue';
import { storeToRefs } from 'pinia';
import { useRoute, useRouter } from 'vue-router';
import { useI18n } from 'vue-i18n';
import { request } from '@/lib/request';
import { usePreviewStore } from '@/stores/preview';
import Schedule from '@/components/preview/schedule/Index.vue';
import Freeform from '@/components/preview/freeform/Index.vue';
import Timeline from '@/components/preview/timeline/Index.vue';
import { notificationStatus, paneTypes } from '@/enums/enums';
import { useBaseStore } from '@/stores/base';

const { t } = useI18n();
const $t = t; 
const router = useRouter();
const route = useRoute();
const baseStore = useBaseStore();
const { message, status } = storeToRefs(baseStore);
const store = usePreviewStore()
const { data, lineArray, commentsAllowed, likesAllowed, paneType, headline, subheadline, style, previewHashcode, isExport } = storeToRefs(store);
const configuration = inject<any>('configuration');

document.title = $t('general.variables.name');
watch(headline, (value)=>{
    document.title = value;
});

const id = route.params.id;
previewHashcode.value = String(id);
const getBoardData = async()=>{
    let result = await request('GET', `${isExport.value?configuration.exportApiServer:configuration.apiServer}/api/boarddata/${id}${isExport.value?'?export=t':'?preview=t'}`);
    if(result && result.success){
        headline.value = result.data.headline;
        subheadline.value = result.data.subheadline;
        data.value = result.data.dataSet;
        if(result.data.previewOptions){
            paneType.value = result.data.previewOptions.type;
            commentsAllowed.value = result.data.previewOptions.commentsAllowed;
            likesAllowed.value = result.data.previewOptions.likesAllowed;
        }else{
            paneType.value = result.data.lineArray?paneTypes.FREEFORM:result.data.style.elementWidth?paneTypes.TIMELINE:paneTypes.SCHEDULE;
            commentsAllowed.value = result.data.style.commentsAllowed;
            likesAllowed.value = result.data.style.likesAllowed;
        }
        if(result.data.lineArray){
            lineArray.value = result.data.lineArray;
        }
        style.value = result.data.style;
    }else{
        message.value = $t('general.variables.pane.sg') + ' ' + $t('general.variables.notExist');
        status.value = notificationStatus.DANGER;
        router.push({name: "home"});
    }
};
getBoardData();

</script>
<template>
<div v-if="data!==null">
    <Freeform v-if="paneType === paneTypes.FREEFORM"/>
    <Schedule v-if="(paneType === paneTypes.SCHEDULE || paneType === paneTypes.STREAM)"/>
    <Timeline v-if="(paneType === paneTypes.TIMELINE)"/>
</div>
</template>